package net.npaka.homeex;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PaintFlagsDrawFilter;
import android.graphics.PixelFormat;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.content.res.Resources;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

//z[XN[
public class HomeEx extends Activity 
    implements AdapterView.OnItemClickListener { 
    private ArrayList<AppInfo> appList;//AvXg
    private final BroadcastReceiver 
        appReceiver=new AppReceiver();//Avo^V[o[
    private GridView gridView;        //Obhr[
        
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundResource(R.drawable.bg);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //Obhr[̐(1)
        gridView=new GridView(this);
        gridView.setNumColumns(4);
        gridView.setGravity(Gravity.CENTER);
        gridView.setOnItemClickListener(this);
        setLLParams(gridView,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.FILL_PARENT);
        layout.addView(gridView);
        
        //AvXg̓ǂݍ
        loadAppList();     

        //Avo^V[o[̊Jn(5)
        IntentFilter filter=
            new IntentFilter(Intent.ACTION_PACKAGE_ADDED);
        filter.addAction(Intent.ACTION_PACKAGE_REMOVED);
        filter.addAction(Intent.ACTION_PACKAGE_CHANGED);
        filter.addDataScheme("package");
        registerReceiver(appReceiver,filter);        
    }   
    
    //AvXg̓ǂݍ
    private void loadAppList() {
        //ANeBreB̃Xg̎擾(3)
        PackageManager manager=getPackageManager();
        Intent intent=new Intent(Intent.ACTION_MAIN,null);
        intent.addCategory(Intent.CATEGORY_LAUNCHER);        
        List<ResolveInfo> apps=manager.queryIntentActivities(intent,0);
        Collections.sort(apps,new ResolveInfo.DisplayNameComparator(manager));

        //ANeBreB̎擾(4)
        appList=new ArrayList<AppInfo>();
        if (apps==null) return;
        for (int i=0;i<apps.size();i++) {
            AppInfo appInfo=new AppInfo();
            ResolveInfo info=apps.get(i);
            appInfo.title=info.loadLabel(manager);
            appInfo.setActivity(
                info.activityInfo.applicationInfo.packageName,
                info.activityInfo.name);
            appInfo.icon=resizeIcon(info.activityInfo.loadIcon(manager));
            appList.add(appInfo);
        }
        
        //Obh̍XV(2)
        gridView.setAdapter(new GridAdapter(this));
    } 
    
    //ACRTCY̕ύX
    private Drawable resizeIcon(Drawable icon) {
        //WACRTCY̎擾
        Resources res=getResources();
        int width =(int)res.getDimension(android.R.dimen.app_icon_size);
        int height=(int)res.getDimension(android.R.dimen.app_icon_size);
        
        //݂̃ACRTCY̎擾
        int iconWidth =icon.getIntrinsicWidth();
        int iconHeight=icon.getIntrinsicHeight();

        //ACRTCY̕ύX
        if (width>0 && height>0 && 
            (width<iconWidth || height<iconHeight)) {
            
            //ϊ̃ACRTCY̌vZ
            float ratio=(float)iconWidth/(float)iconHeight;
            if (iconWidth>iconHeight) {
                height=(int)(width/ratio);
            } else if (iconHeight>iconWidth) {
                width=(int)(height*ratio);
            }

            //ILoX̐
            Bitmap.Config c=(icon.getOpacity()!=PixelFormat.OPAQUE)?
                Bitmap.Config.ARGB_8888:Bitmap.Config.RGB_565;
            Bitmap thumb=Bitmap.createBitmap(width,height,c);
            Canvas canvas=new Canvas(thumb);
            canvas.setDrawFilter(new PaintFlagsDrawFilter(Paint.DITHER_FLAG,0));

            //ILoXւ̃ACR`
            Rect oldBounds=new Rect();
            oldBounds.set(icon.getBounds());
            icon.setBounds(0,0,width,height);
            icon.draw(canvas);
            icon.setBounds(oldBounds);
            
            //LoXDrawableIuWFNgɕϊ
            icon=new BitmapDrawable(thumb);
        }        
        return icon;
    }

    //ObhACẽNbNCxg
    public void onItemClick(AdapterView<?> parent,View v,int position,long id) {
        //ANeBreB̋N
        AppInfo appInfo=(AppInfo)parent.getItemAtPosition(position);
        startActivity(appInfo.intent);
    }    

    //Av̉
    @Override
    public void onDestroy() {
        super.onDestroy();
        
        //Avo^V[o[̉
        unregisterReceiver(appReceiver);
    }    
    
    //BACKL[̖(6)
    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        if (event.getAction()==KeyEvent.ACTION_DOWN) {
            switch (event.getKeyCode()) {
                case KeyEvent.KEYCODE_BACK:
                    return true;
            }
        }
        return super.dispatchKeyEvent(event);
    }

    //ObhA_v^̐(2)
    public class GridAdapter extends BaseAdapter {
        private Context context;//ReLXg

        //RXgN^
        public GridAdapter(Context c) {
            context=c;
        }

        //ڐ̎擾
        public int getCount() {
            return appList.size();
        }

        //ڂ̎擾
        public Object getItem(int position) {
            return appList.get(position);
        }

        //ID̎擾
        public long getItemId(int position) {
            return position;
        }

        //r[̎擾
        public View getView(int position,View convertView,ViewGroup parent) {
            TextView textView=new TextView(context);
            textView.setWidth(78);
            textView.setHeight(65);
            textView.setSingleLine(true);
            textView.setTextSize(12.0f);
            textView.setGravity(Gravity.CENTER_HORIZONTAL);
            textView.setTextColor(Color.rgb(0,0,0));
            textView.setCompoundDrawablesWithIntrinsicBounds(null,
                appList.get(position).icon,
                null,null);
            textView.setText(appList.get(position).title);
            return textView;
        }
    }

    //Avo^V[o[(5)
    private class AppReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context,Intent intent) {
            //AvXg̓ǂݍ
            loadAppList(); 
        }
    }

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}