package net.npaka.sensorex;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.view.View;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.util.List;

//xZT[̗p
public class SensorEx extends Activity 
    implements SensorEventListener {
    private TextView      textView;     //eLXgr[
    private TickHandler   tickHandler;  //nh
    private SensorManager sensorManager;//ZT[}l[W
    private Sensor        accelerometer;//xT[
    private Sensor        orientation;  //]T[
    private float[] values=new float[6];//xƌXl

    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //eLXgr[̐
        textView=new TextView(this);
        textView.setText("SensorEx");
        textView.setTextSize(24.0f);
        textView.setTextColor(Color.rgb(0,0,0));
        setLLParams(textView);
        layout.addView(textView);
        
        //ZT[}l[W̎擾(1)
        sensorManager=(SensorManager)getSystemService(
            Context.SENSOR_SERVICE);
        
        //ZT[̎擾(2)
        List<Sensor> list;
        list=sensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
        if (list.size()>0) accelerometer=list.get(0);
        list=sensorManager.getSensorList(Sensor.TYPE_ORIENTATION);
        if (list.size()>0) orientation=list.get(0);
    }

    //Av̊Jn
    @Override
    protected void onResume() {
        //Av̊Jn
        super.onResume();
        
        //ZT[̏̊Jn(3)
        if (accelerometer!=null) {
            sensorManager.registerListener(this, 
        	    accelerometer,SensorManager.SENSOR_DELAY_FASTEST);
        }
        if (orientation!=null) {
            sensorManager.registerListener(this, 
                orientation,SensorManager.SENSOR_DELAY_FASTEST);
        }
        
        //̊Jn
        tickHandler=new TickHandler();
        tickHandler.sleep(0);            
    }
    
    //Av̒~
    @Override
    protected void onStop() {
        //Av̒~
        super.onStop();

        //ZT[̏̒~(4)
        sensorManager.unregisterListener(this);
        
        //̒~
        tickHandler=null;
    }
    
    //ZT[Xi[̏(5)
    public void onSensorChanged(SensorEvent event) {
        //x̎擾
        if (event.sensor==accelerometer) {
            values[0]=event.values[0];
            values[1]=event.values[1];
            values[2]=event.values[2];
        }
        //̎擾
        if (event.sensor==orientation) {
            values[3]=event.values[0];
            values[4]=event.values[1];
            values[5]=event.values[2];
        }
    }

    //xύXCxg̏
    public void onAccuracyChanged(Sensor sensor,int accuracy) {
    }

    //nh
    public class TickHandler extends Handler {
        //nhbZ[W
        @Override 
        public void handleMessage(Message msg) {
            String text="SensorEx"+
                "\nXx:"+values[0]+
                "\nYx:"+values[1]+
                "\nZx:"+values[2]+
                "\n:"    +values[3]+
                "\nsb`:"  +values[4]+
                "\n[:"  +values[5];
            textView.setText(text);
            if (tickHandler!=null) tickHandler.sleep(200);
        }
        
        //X[v
        public void sleep(long delayMills) {
            removeMessages(0);
            sendMessageDelayed(obtainMessage(0),delayMills);
        }
    }

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }
}