package net.npaka.texttospeechex;
import java.util.Locale;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

//
public class TextToSpeechEx extends Activity 
    implements View.OnClickListener,TextToSpeech.OnInitListener {
    private EditText     editText;//GfBbgeLXg
    private Button       button;  //{^
    private TextToSpeech tts;     //TTS
    
    //Av̏
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        editText.setText("This is TEST!",
            EditText.BufferType.NORMAL);
        setLLParams(editText,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);
        layout.addView(editText);
        
        //{^̐
        button=new Button(this);
        button.setText("");
        button.setOnClickListener(this);
        setLLParams(button);  
        layout.addView(button);
        
        //̏(1)
        tts=new TextToSpeech(this,this);
    }

    //̏ɌĂ΂(1)
    public void onInit(int status) {
        if (status==TextToSpeech.SUCCESS) {
            //̃P[w(2)
            Locale locale=Locale.ENGLISH;
            if (tts.isLanguageAvailable(locale)>=
                TextToSpeech.LANG_AVAILABLE) {
                tts.setLanguage(locale);
            } else {
                Toast.makeText(TextToSpeechEx.this,
                    "Unsupported Language",Toast.LENGTH_LONG).show();
            }
        } else if (status==TextToSpeech.ERROR) {
            Toast.makeText(TextToSpeechEx.this,
                "TextToSpeech.ERROR",Toast.LENGTH_LONG).show();
        }
    }

    //AvIɌĂ΂
    protected void onDestroy() {
        super.onDestroy();
        
        //̏I(4)
        if (tts!=null) tts.shutdown();
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        String str=editText.getText().toString();
        if (str.length()>0) {
            //Xs[`̒~
            if (tts.isSpeaking())tts.stop();
            
            //Xs[`̍Đ
            tts.setSpeechRate(1.0f);
            tts.speak(str,TextToSpeech.QUEUE_FLUSH,null);
        }
    }    
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}