package net.npaka.twitterclient;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import org.apache.http.HttpResponse;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.xmlpull.v1.XmlPullParser;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Xml;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

//TwitterNCAg
public class TwitterClient extends Activity {
    //萔
    private static final int 
        MENU_SETUP =0,
        MENU_UPDATE=1;
    private static final int 
        RQ_SETUP=0;

    //
    private ListView listView;
    private static HashMap<String,Drawable> icons=
        new HashMap<String,Drawable>();
    private ArrayList<Status> timeline=
        new ArrayList<Status>();

    //Av̏
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        
        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //Xgr[̐(1)
        listView=new ListView(this);
        setLLParams(listView);
        layout.addView(listView);
        
        //^CC̍XV
        updateTimeline();
    }

    //IvVj[̐
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        MenuItem item0=menu.add(0,MENU_SETUP,0,"ݒ");
        item0.setIcon(android.R.drawable.ic_menu_add);
        MenuItem item1=menu.add(0,MENU_UPDATE,0,"XV");
        item1.setIcon(android.R.drawable.ic_menu_call);
        return true;
    }    

    //j[ACeICxg̏
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        try {
            switch (item.getItemId()) {
            //ݒ
            case MENU_SETUP:
                Intent intent=new Intent(this,
                    net.npaka.twitterclient.TwitterSetup.class);
                    startActivityForResult(intent,RQ_SETUP);
                return true;
            //XV
            case MENU_UPDATE:
                updateTimeline();
                return true;
            }
        } catch (Exception e) {
        }
        return true;
    }
    
    //ANeBreBĂяoʂ̎擾
    @Override
    protected void onActivityResult(int requestCode,
        int resultCode,Intent intent) {
        if (requestCode==RQ_SETUP && resultCode==RESULT_OK) {
            updateTimeline();
        }
    }    
    
    //^CC̍XV
    private void updateTimeline() {
        try {
            //vt@X̓ǂݍ
            SharedPreferences pref=getSharedPreferences(
                    "setup",MODE_PRIVATE);
            String name    =pref.getString("name","");
            String password=pref.getString("password","");
            if (name==null || password==null ||
                name.length()==0 || password.length()==0) return;
            
            //^CC̍XV
            timeline=timeline(name,password);
            for (int i=0;i<timeline.size();i++) {
                timeline.get(i).icon=readIcon(timeline.get(i).iconURL);
            }
            listView.setAdapter(new TwitterAdapter(this));
        } catch (Exception e) {
            Toast toast=Toast.makeText(
                this,e.toString(),Toast.LENGTH_SHORT);
            toast.show();
        }
    }
    
    //ACR̓ǂݍ
    private Drawable readIcon(String url) throws Exception {
        Drawable drawable=icons.get(url);
        if (drawable!=null) return drawable;
        byte[] data=http2data(url);
        Bitmap bmp=BitmapFactory.decodeByteArray(data,0,data.length);
        drawable=new BitmapDrawable(bmp);
        icons.put(url,drawable);
        return drawable;
    }

    //HTTPʐM
    private byte[] http2data(String path) throws Exception {
        int size;
        byte[] w=new byte[1024]; 
        HttpURLConnection c=null;
        InputStream in=null;
        ByteArrayOutputStream out=null;
        try {
            //HTTPڑ̃I[v
            URL url=new URL(path);
            c=(HttpURLConnection)url.openConnection();
            c.setRequestMethod("GET");
            c.connect();
            in=c.getInputStream();
            
            //oCgz̓ǂݍ
            out=new ByteArrayOutputStream();
            while (true) {
                size=in.read(w);
                if (size<=0) break;
                out.write(w,0,size);
            }
            out.close();

            //HTTPڑ̃N[Y
            in.close();
            c.disconnect();
            return out.toByteArray();
        } catch (Exception e) {
            try {
                if (c!=null) c.disconnect();
                if (in!=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }
    //^CC̎擾
    private ArrayList<Status> timeline(String name,String password) 
        throws Exception {
        ArrayList<Status> timeline=new ArrayList<Status>();
        Status status =null;
        String tagName=null;
        InputStream in=null;
        try {
            //BASICF؂ɂʐM(3)
            DefaultHttpClient http=new DefaultHttpClient();
            http.getCredentialsProvider().setCredentials(
                new AuthScope("twitter.com",80),
                new UsernamePasswordCredentials(name,password));
            HttpResponse execute=http.execute(new HttpGet(
                "http://twitter.com/statuses/friends_timeline.xml"));
            in=execute.getEntity().getContent();
            
            //XML̃p[X(4)
            final XmlPullParser parser=Xml.newPullParser();
            parser.setInput(new InputStreamReader(in));
            while (true) {
                int type=parser.next();
                //hLgJn
                if (type==XmlPullParser.START_DOCUMENT) {
                } 
                //^OJn
                else if (type==XmlPullParser.START_TAG) {
                    tagName=parser.getName();
                    if (tagName.equals("status")) {
                        status=new Status();
                        timeline.add(status);
                    }
                } 
                //eLXg
                else if (type==XmlPullParser.TEXT) {
                    if (parser.getText().trim().length()==0) {
                    } else if (tagName.equals("screen_name")) {
                        status.name=parser.getText();
                    } else if (tagName.equals("text")) {
                        status.text=parser.getText();
                    } else if (tagName.equals("profile_image_url")) {
                        status.iconURL=parser.getText();
                    }
                } 
                //^OI
                else if (type==XmlPullParser.END_TAG) {
                } 
                //hLgI
                else if (type==XmlPullParser.END_DOCUMENT) {
                    break;
                }                
            }

            //ؒf
            in.close();
        } catch (Exception e) {
            try {
                if (in!=null) in.close();
            } catch (Exception e2) {
            }
            throw e;
        }
        return timeline;
    }

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }
    
    //TwitterA_v^̐(2)
    public class TwitterAdapter extends BaseAdapter {
        private Context context;

        //RXgN^
        public TwitterAdapter(Context c) {
            context=c;
        }

        //ڐ̎擾
        public int getCount() {
            return timeline.size();
        }

        //ڂ̎擾
        public Object getItem(int position) {
            return timeline.get(position);
        }

        //ID̎擾
        public long getItemId(int position) {
            return position;
        }

        //r[̎擾
        public View getView(int position,View convertView,ViewGroup parent) {
            TextView textView=new TextView(context);
            textView.setTextSize(12.0f);
            textView.setCompoundDrawablesWithIntrinsicBounds(
                timeline.get(position).icon,null,null,null);
            textView.setText("["+timeline.get(position).name+"]\n"+
                timeline.get(position).text);
            return textView;
        }
    }
}